﻿using DevExpress.ExpressApp;
using DevExpress.ExpressApp.Actions;
using DevExpress.ExpressApp.Editors;
using DevExpress.ExpressApp.SystemModule;
using DevExpress.ExpressApp.Win.Editors;
using DevExpress.Persistent.Base;
using System;

namespace Xafari.Business
{
    public partial class TestController : ViewController
    {
        public TestController()
        {
            IObjectSpace objectSpace;

            InitializeComponent();

            TargetViewType = ViewType.ListView;

            SimpleAction testAction =
                new SimpleAction(
                    this,
                    "Test action",
                    PredefinedCategory.RecordEdit)
                {
                    ImageName = "Find"
                };

            testAction.Execute += (s, e) => {

                string currentObject = "CurrentObject";

                objectSpace = Application.CreateObjectSpace(typeof(TestObject));

                TestObject testObject = new TestObject();

                DetailView detailView = Application.CreateDetailView(objectSpace, testObject);

                StringPropertyEditor item = new StringPropertyEditor(typeof(string), null) { CurrentObject = currentObject };

                detailView.InsertItem(detailView.Items.Count, item);

                detailView.ViewEditMode = ViewEditMode.Edit;

                DialogController dialogController = new DialogController();
                dialogController.Accepting += DialogController_Accepting;
                dialogController.Cancelling += DialogController_Cancelling;

                e.ShowViewParameters.Controllers.Add(dialogController);
                e.ShowViewParameters.TargetWindow = TargetWindow.Default;
                e.ShowViewParameters.CreatedView = detailView;
            };
        }

        protected override void OnActivated()
        {
            base.OnActivated();
        }
        protected override void OnViewControlsCreated()
        {
            base.OnViewControlsCreated();
        }
        protected override void OnDeactivated()
        {
            base.OnDeactivated();
        }
        void DialogController_Accepting(object sender, DialogControllerAcceptingEventArgs e)
        {
            if (!(sender is DialogController dialogController)) return;
            if (!(dialogController.Frame.View is DetailView detailView)) return;
        }
        void DialogController_Cancelling(object sender, EventArgs e)
        {
            if (sender is DialogController dialogController)
                dialogController.Frame.View.ObjectSpace.Rollback();
        }
    }
}
